#include <bits/stdc++.h>

using namespace std;

const int maxn = 10010;
const long long mod = 1e9 + 7;

vector < pair <int, int> > fs[maxn];
int id[maxn];
int primeNumber;

void precalc() {
    primeNumber = 0;
    for (int i = 2; i < maxn; i++) {
        bool prime = true;
        for (int j = 2; j * j <= i; j++)
            if (j % i == 0)
                prime = false;
        if (prime)
            id[i] = primeNumber++;
    }
    for (int i = 2; i < maxn; i++) {
        int x = i;
        for (int j = 2; j * j <= x; j++) {
            int power = 0;
            while (x % j == 0)
                ++power, x /= j;
            if (power > 0)
                fs[i].push_back(make_pair(j, power));
        }
        if (x > 1)
            fs[i].push_back(make_pair(x, 1));
    }
}

int main() {
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);
    int n;
    scanf("%d", &n);
    precalc();
    vector <int> a(n);
    for (int i = 0; i < n; i++)
        scanf("%d", &a[i]);
    int q;
    scanf("%d", &q);
    for (int it = 0; it < q; it++) {
        int type;
        scanf("%d", &type);
        if (type == 0) {
            int pos, value;
            scanf("%d%d", &pos, &value);
            --pos;
            a[pos] = value;
        } else {
            int l, r;
            scanf("%d%d", &l, &r);
            --l, --r;
            vector <int> cnt(primeNumber, 0);
            for (int i = l; i <= r; i++) {
                for (size_t iter = 0; iter < fs[a[i]].size(); iter++)
                    cnt[fs[a[i]][iter].first] += fs[a[i]][iter].second;
            }
            long long ans = 1;
            for (int i = 0; i < primeNumber; i++)
                ans = ans * (cnt[i] + 1) % mod;
            printf("%I64d\n", ans);
        }
    }
    return 0;
}