#include<iostream>
#include<cstdio>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<vector> 
#include<cstring>
#include<string>
#include<map>
#define mp make_pair
#define scn second
#define frs first
#define pb push_back

#define NAME "netree"

using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, int> pi;
const int P = 239017;
const int INF = 1000000000;


int mtr[500][500], new_mtr[500][500], used[500], p[500], d[500], need_d[500], mtr1[500][500];
int n, s = 1, c = 0;
int was[1000];
void dfs(int v) {
	++c;
	used[v] = 1;
	for (int i = 1; i <= n; ++i)
		if (mtr[v][i] && !used[i])
			dfs(i);
}


int main(){
    freopen(NAME ".in", "r", stdin); 
    freopen(NAME ".out", "w", stdout); 
    scanf("%d", &n);
    for (int i = 1; i <= n; ++i) {
    	for (int j = 1; j <= n; ++j) {
    		scanf("%d", &mtr[i][j]);
    		mtr1[i][j] = mtr[i][j];
    	}
    }
    for (int k = 1; k <= n; ++k) {
    	for (int i = 1; i <= n; ++i)
    		for (int j = 1; j <= n; ++j)
    			mtr[i][j] = min(mtr[i][j], mtr[i][k] + mtr[k][j]);
    }    
    for (int i = 1; i <= n; ++i) {
    	for (int j = 1; j <= n; ++j) {
    		if (i != j && mtr1[j][i] != INF && mtr[1][i] == mtr[1][j] + mtr1[j][i])
    			new_mtr[j][i] = 1; 
    	}
    }
    
    swap(new_mtr, mtr);
	/*   
    for (int i = 1; i <= n; ++i, printf("\n"))
		for (int j = 1; j <= n; ++j)
			printf("%d ", mtr[i][j]);
	*/

    int ans = 0;
	for (int v = 2; v <= n; ++v) {
		int tmp = 0;
		for (int i = 1; i <= n; ++i)
			tmp += mtr[i][v];
		if (tmp > 1 || tmp == 0)
			continue;
		for (int i = 1; i <= n; ++i)
			used[i] = 0, was[i] = 0;
		c = 0;
		dfs(v);
		int K = c;
		vector<int> t;
		for (int i = 1; i <= n; ++i) 
			for (int j = 1; j <= n; ++j) {
				if (j != v && used[j] && mtr[i][j] && !used[i] && !was[j])
					t.pb(j), was[j] = 1;
			}
		for (int i = 1; i <= n; ++i)
			used[i] = 0;				
		for (int i = 0; i < t.size(); ++i) {
			if (!used[t[i]]) {
				c = 0;
				dfs(t[i]);
				K -= c;
			}
	   	}
		ans = max(ans, K);	   	
    }        
    printf("%d", ans);
    return 0;
}







