#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
using namespace std;

const int INF = (int)1e9;

int main()
{
    int n;
    freopen("run.in", "r", stdin);
    freopen("run.out", "w", stdout);
    cin >> n;
    vector<string> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    vector<vector<int> > dp(n, vector<int>(3, -INF));
    for (int i = 0; i < 3; i++)
    {
        if (s[0][i] == 'W')
            dp[0][i] = -INF;
        if (s[0][i] == 'C')
            dp[0][i] = 1;
        if (s[0][i] == '.')
            dp[0][i] = 0;
    }
    for (int i = 1; i < n; i++)
        for (int j = 0; j < 3; j++)
            for (int k = -1; k < 2; k++)
                if (j + k >= 0 && j + k < 3)
                {
                    int cur = dp[i - 1][j + k];
                    if (s[i][j] == 'W' || cur == -INF)
                        continue;
                    if (s[i][j] == 'C')
                        cur++;
                    dp[i][j] = max(dp[i][j], cur);
                }
    int ans = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < 3; j++)
            ans = max(ans, dp[i][j]);
    /*for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < 3; j++)
            cout << dp[i][j] << ' '; 
        cout << endl;
    }*/
    cout << ans << endl;
    return 0;
}