#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

string to_string(int n)
{
    if (n == 0)
        return "0";
    string res = "";
    while (n > 0)
        res += (n % 10) + '0', n /= 10;
    reverse(res.begin(), res.end());
    return res;
}

bool cmp(int a, int b)
{
    string x = to_string(a) + to_string(b);
    string y = to_string(b) + to_string(a);
    //cerr << x << ' ' << y << ' ' << (bool)(x > y) << endl;
    return x > y;
}


int main()
{
    int n;
    freopen("maxnumber.in", "r", stdin);
    freopen("maxnumber.out", "w", stdout);
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    sort(a.begin(), a.end(), cmp);
    for (int i = 0; i < n; i++)
        cout << a[i] << ' ';
    return 0;
}