#include <iostream>
#include <cstdio>
#include <vector>

const int maxn = 1 << 17;

using namespace std;

int n, a[maxn], b[maxn];
vector<int> e[50];

void solve(int k) {
	if (k == 2 * n) return;
	int x = n - k / 2 - 1;
	for (int i = 0; i < (int)e[k].size(); i++) {
	 	if (e[k][i] & (1 << x)) {
			printf("%d ", k + 1);
	 	    e[k + 1].push_back(e[k][i]);
		} else {
		 	printf("%d %d ", k + 1, k + 2);
			e[k + 2].push_back(e[k][i]);
		}
	}
	e[k].clear();
	solve(k + 2);
	for (int i = (int)e[k + 1].size() - 1; i >= 0; i--) {
		printf("%d ", k + 2);
	 	e[k + 2].push_back(e[k + 1][i]);
	}
	e[k + 1].clear();
	solve(k + 2);
}

int main() {
 	freopen("stacks.in", "r", stdin);
	freopen("stacks.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < 1 << n; i++) {
		int x;
		scanf("%d", &x);
	 	e[0].push_back(--x);
	}
	
	solve(0);	
		
	return 0;
}